/*--------------------------------------------------------------------------*
  Project:    HWR_Demo
  File:       demo.cpp

  Copyright (C) 2011 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/
/******************************************************************
                        include t@C
*******************************************************************/
#include <nn.h>
#include <nn/os.h>
#include <nn/fs.h>
#include <nn/applet.h>

#include "hwr_sample.h"
#include "hwr_wrap.h"

extern "C"
{
char* getDicName(int);
char* getModeName(int);
char* getInkName(int);
unsigned char* getInkData(int index);
unsigned short getInkCode(int index);
char* getRegInkName(int index, int type );
unsigned short getRegInkCode(int index);
unsigned char* getRegInkData(int index);
unsigned short getModeType(int);
void hwrMW_Init( int dicIdx, unsigned char* pRegMem );
void hwrMW_End( void );
void hwrMW_Exec( int modeIdx, int inkIdx, bool resultMode );

}


unsigned char gRegDicMem[INK_NUM_MAX*512];
unsigned char gRegistIDat[DLL_SEND_INKS*2];

void HWR_Main( void )
{
    short libRet;

    int dicCnt=0;
    int modeCnt=0;
    int inkCnt=0;
    int regNum=0;
    volatile bool loop0=true;
    volatile bool loop1=true;
    volatile bool loop2=true;
    bool bOutputMode = true;
    bool bRegInitMode=true;
    unsigned short regEcode[INK_NUM_MAX];
    char*  inkCodeName = NULL;
    char*  regCodeName = NULL;
    long regInkDataSize = 0;
    unsigned char* regIDat = NULL;

    static char* stOutputMode[2] ={"Normal","Regist"};
    static char* stRegInitMode[2]={"New","Read"};

    int autExecFlag = D_USE_KEYEVENT;



    memset( gRegDicMem, 0, sizeof(gRegDicMem));
    hwrMW_Init(0, gRegDicMem);


    PRINT_OUT("Demo Start\n");

START:
    UTILITY_INIT( SINARIO_FILE );
    autExecFlag = D_USE_KEYEVENT;
    loop0 = true;

    /////////////////////////////////////////////////
    // s[h̑I
    /////////////////////////////////////////////////
    while(loop0){
        PRINT_OUT("\n/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/\n\n");
       
        // 
        PRINT_OUT("  [A]     Use Controller\n");
        PRINT_OUT("  [B]     Use Sinario File\n");
        PRINT_OUT("  [START] Application Exit\n");
        PRINT_OUT("\n\n");
    
        PRINT_OUT(" \n");
        PRINT_OUT(" Input KEY = ?\n");
        PRINT_OUT(" \n");

        switch( GET_KEY_EVENT( autExecFlag ) ){
        // [A] ꂽ
        case D_BUTTON_A:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[A]     Pushed :Use Controller\n");
            PRINT_OUT("=============================================\n");
            loop0=false;
            break;

        // [X] ꂽ
        case D_BUTTON_B:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[B]     Pushed :Use Sinario File\n");
            PRINT_OUT("=============================================\n");
            loop0=false;
            autExecFlag = D_USE_SINARIO;
            break;
        // [START] ꂽ
        case D_BUTTON_START:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[START]  Pushed :Application Exit\n");
            PRINT_OUT("=============================================\n");
            PRINT_OUT( " Finish!!\n");
            goto FINISH;
        default:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[!!!!]   Pushed :Invalid Key !!\n");
            PRINT_OUT("=============================================\n");
            break;
        }
    
    }

CHANGE_DIC:
    loop1 = true;
    /////////////////////////////////////////////////
    // ̑I
    /////////////////////////////////////////////////

    while(loop1){
        PRINT_OUT("\n/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/\n\n");
       
        // 
        PRINT_OUT("  [A]     Detect Dic\n");
        PRINT_OUT("  [UP]    Change Dic (+)\n");
        PRINT_OUT("  [DOWN]  Change Dic (-)\n");
        PRINT_OUT("  [START]  Exit\n");
        PRINT_OUT("\n\n");

        PRINT_OUT("   << Current Setting>>      \n");
        PRINT_OUT("      dic = %s\n", getDicName(dicCnt));

        PRINT_OUT(" \n");
        PRINT_OUT(" Input KEY = ?\n");
        PRINT_OUT(" \n");

        switch( GET_KEY_EVENT( autExecFlag ) ){
        // [A] ꂽ
        case D_BUTTON_A:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[A]     Pushed :Detect Dic\n");
            PRINT_OUT("=============================================\n");
            PRINT_OUT("    dic = %s\n", getDicName(dicCnt));

            hwrMW_End();

            memset( gRegDicMem, 0, sizeof(gRegDicMem));
            hwrMW_Init(dicCnt, gRegDicMem);
            loop1=false;

            break;

        // [] ꂽ
        case D_BUTTON_UP:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[UP]    Pushed :Change Dic (+)\n");
            PRINT_OUT("=============================================\n");

            if( dicCnt < DIC_NUM_MAX-1 ){
                dicCnt++;
            }else{
                dicCnt=0;
            }
            PRINT_OUT("    [set Dic=%s]\n", getDicName(dicCnt));
            break;


        // [] ꂽ
        case D_BUTTON_DOWN:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[DOWN]  Pushed :Change Dic (-)\n");
            PRINT_OUT("=============================================\n");
            if( dicCnt == 0 ){
                dicCnt = DIC_NUM_MAX -1;
            }else{
                dicCnt--;
            }
            PRINT_OUT("    [set Dic=%s]\n", getDicName(dicCnt));
            break;

        // [START] ꂽ
        case D_BUTTON_START:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[START]  Pushed :START\n");
            PRINT_OUT("=============================================\n");
            UTILITY_TERM();
            goto START;

        // [ViI EOF]
        case D_BUTTON_SINARIO_EOF:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[Sinario File End]\n");
            PRINT_OUT("=============================================\n");
            loop1=false;
            loop2=false;
            break;
        default:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[!!!!]   Pushed :Invalid Key !!\n");
            PRINT_OUT("=============================================\n");
            break;

        }
    }


    regNum=0;
    modeCnt=0;
    inkCnt=0;
    while(loop2){
        PRINT_OUT("\n/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/\n\n");
       
        // 
        PRINT_OUT("  [A]     Exec Start\n");
        PRINT_OUT("  [B]     OutputMode Normal/Regist (toggle)\n");
        PRINT_OUT("  [X]     Register Set\n");
        PRINT_OUT("  [Y]     Register Delete\n");
        PRINT_OUT("  [RIGHT] Next InkData\n");
        PRINT_OUT("  [LEFT]  Back InkData\n");
        PRINT_OUT("  [UP]    Change Mode (+)\n");
        PRINT_OUT("  [DOWN]  Change Mode (-)\n");
        PRINT_OUT("  [L]     Save Regist Data\n");
        PRINT_OUT("  [R]     Select Init New/Read\n");
        PRINT_OUT("  [START] Exit\n");
        PRINT_OUT("\n\n");


        // [A]   Fs
        // [B]   s[hؑ
        //   1:RT_Exec()+Register_Result()     [Defalut]
        //   0:RT_Exec()̂
        // [X]   Register_Set    S
        // [Y]   Register_Delete S
        // []  ̕
        // []  O̕
        // [L]   Regist  ۑ
        // [R]  o^[hؑ
        //   1:RT_Register_Init()VK               [Default]
        //   0:RT_Register_Init()̓ǂݍ


        PRINT_OUT("   << Current Setting>>      \n");
        PRINT_OUT("      dic = %s\n", getDicName(dicCnt));
        PRINT_OUT("      mode= %s<0x%04x>\n", getModeName(modeCnt), getModeType(modeCnt));
        PRINT_OUT("      ink = %s [%d/%d]\n", getInkName(inkCnt), inkCnt+1, INK_NUM_MAX);

        PRINT_OUT("      outputMode = %s\n", stOutputMode[bOutputMode]);
        PRINT_OUT("      RegistMode = %s\n", stRegInitMode[bRegInitMode]);
        PRINT_OUT("      RegistInfo\n");

        if( regNum != 0 ){

            memset( regEcode, 0 , sizeof(regEcode) );
            int num = WRAP_RegisterInfo( regEcode );

            if( num > 0 ){
               for( int cnt=0; cnt<num; cnt++){
                   PRINT_OUT("        RegistCode[%d] = 0x%04X\n", cnt, regEcode[cnt]);
               }
            }
        }else{
            PRINT_OUT("        RegistCode[ ] = None\n");
        }

        PRINT_OUT(" \n");
        PRINT_OUT(" Input KEY = ?\n");
        PRINT_OUT(" \n");

        switch( GET_KEY_EVENT( autExecFlag ) ){
        // [A] ꂽ
        case D_BUTTON_A:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[A]     Pushed :ExecStart\n");
            PRINT_OUT("=============================================\n");

            PRINT_OUT("    dic = %s\n", getDicName(dicCnt));
            PRINT_OUT("    mode= %s<0x%04x>\n", getModeName(modeCnt), getModeType(modeCnt));
            PRINT_OUT("    ink= %s [%d/%d]\n\n", getInkName(inkCnt), inkCnt+1, INK_NUM_MAX);
            PRINT_OUT("    RegistMode = %s\n", stRegInitMode[bRegInitMode]);

            hwrMW_Exec( modeCnt,inkCnt,bOutputMode );
            break;

        // [B] ꂽ
        case D_BUTTON_B:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[B]     Pushed :OutputMode Normal/Regist (toggle)\n");
            PRINT_OUT("=============================================\n");

            if(bOutputMode){
                bOutputMode = false;
            }else{
                bOutputMode = true;
            }
            break;

        // [] ꂽ
        case D_BUTTON_UP:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[UP]    Pushed :Change Mode (+)\n");
            PRINT_OUT("=============================================\n");
    
            if( modeCnt < (MOD_NUM_MAX -1)){
                modeCnt++;
            }else{
                modeCnt=0;
            }
            PRINT_OUT("    [set Mode=%s(0x%04x)]\n", getModeName(modeCnt), getModeType(modeCnt));
            break;

        // [] ꂽ
        case D_BUTTON_DOWN:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[DOWN]  Pushed :Change Mode (-)\n");
            PRINT_OUT("=============================================\n");

            if( modeCnt == 0 ){
                modeCnt = MOD_NUM_MAX -1;
            }else{
                modeCnt--;
            }
            PRINT_OUT("    [set Mode=%s(0x%04x)]\n", getModeName(modeCnt), getModeType(modeCnt));
            break;

        // [->] ꂽ
        case D_BUTTON_RIGHT:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[RIGHT] Pushed :Next InkData\n");
            PRINT_OUT("=============================================\n");

            if( inkCnt < ( INK_NUM_MAX-1 )){
                inkCnt++;
            }else{
                inkCnt=0;
            }
            PRINT_OUT("    [set Ink=%s  (%d/%d)\n", getInkName(inkCnt), inkCnt+1, INK_NUM_MAX);

            // ink data؂ւ烂[hB
            modeCnt=0;
            break;

       // [<-] ꂽ
        case D_BUTTON_LEFT:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[LEFT]  Pushed :Back InkData\n");
            PRINT_OUT("=============================================\n");

            if( inkCnt == 0 ){
                inkCnt = INK_NUM_MAX -1;
            }else{
                inkCnt--;
            }
            PRINT_OUT("    [set Ink=%s  (%d/%d)\n", getInkName(inkCnt), inkCnt+1, INK_NUM_MAX);

            // ink data؂ւ烂[hB
            modeCnt=0;
            break;


        // [X] ꂽ
        case D_BUTTON_X:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[X]     Pushed :Register Set\n");
            PRINT_OUT("=============================================\n");

            if( regNum == 0 ){
                for( int cnt=0; cnt<INK_NUM_MAX; cnt++ ){
                    inkCodeName = getRegInkName(cnt, D_ORG_CODE);
                    regCodeName = getRegInkName(cnt, D_REG_CODE);

                    PRINT_OUT("    Register_Set() %s -> %s\n", inkCodeName, regCodeName );

                    /* MՃf[^̎擾 */
                    memset( gRegistIDat, 0 , sizeof(gRegistIDat ));
                    regIDat = getRegInkData(cnt);
                    strcpy( (char *)gRegistIDat, (const char*)regIDat );
    
                    /* MՂ̃f[^擾 */
                    regInkDataSize = (long)strlen( (const char*)regIDat );
    
                    /* I_f[^ݒ */
                    gRegistIDat[regInkDataSize + 0]=0xFF;
                    gRegistIDat[regInkDataSize + 1]=0xFF;


                    libRet = WRAP_RegisterSet( getRegInkCode(cnt), gRegistIDat );
                    if( libRet > RT_OK ){
                        regNum++;
                    }else{
                        PRINT_OUT("[ERROR] RT_Register_Set() Error = %d\n", libRet );
                    }
                }
            }
            break;

        // [Y] ꂽ
        case D_BUTTON_Y:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[Y]     Pushed :Register Delete\n");
            PRINT_OUT("=============================================\n");

            // o^Ă錏A폜
            for( int cnt=0; cnt<regNum; cnt++ ){
                WRAP_RegisterDelete( getRegInkCode(cnt));
            }
            regNum=0;
            break;

        // [L] ꂽ
        case D_BUTTON_L:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[L]     Pushed :Save Regist Data\n");
            PRINT_OUT("=============================================\n");

            break;

        // [R] ꂽ
        case D_BUTTON_R:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[R]     Pushed :Select Init New/Read\n");
            PRINT_OUT("=============================================\n");

            // o^[h̐؂ւ
            // VKo^
            if(bRegInitMode){
                bRegInitMode = false;
                WRAP_RegisterFinalize();
                memset( gRegDicMem, 0, sizeof(gRegDicMem));
                WRAP_RegisterInitialize( INK_NUM_MAX, gRegDicMem );
            // f[^̓o^ 
            // TODO
            }else{
                bRegInitMode = true;
                WRAP_RegisterFinalize();
                memset( gRegDicMem, 0, sizeof(gRegDicMem));
                WRAP_RegisterInitialize( INK_NUM_MAX, gRegDicMem ); // TODO
            }
            break;

        // [START] ꂽ
        case D_BUTTON_START:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[START]  Pushed :Change Dic\n");
            PRINT_OUT("=============================================\n");

            PRINT_OUT( " ChangeDic\n");
            memset( gRegDicMem, 0, sizeof(gRegDicMem));
            hwrMW_End();
            goto CHANGE_DIC;

        case D_BUTTON_SINARIO_EOF:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[Sinario File End]\n");
            PRINT_OUT("=============================================\n");
            loop2=false;
            break;
        default:
            PRINT_OUT("=============================================\n");
            PRINT_OUT("[!!!!]   Pushed :Invalid Key !!\n");
            PRINT_OUT("=============================================\n");
            break;

        }
    }

FINISH:
    hwrMW_End();
}


void AppCommonInit(void)
{
    nn::Result result;

    // fs ̏
    nn::fs::Initialize();

    // hid ̏
    result = nn::hid::Initialize();

    // z[j[sł悤 nn::applet::Enable() ̂݌Ă
    // z[j[Jڂd{^NbNAX[vɂ͔Ή
    nn::applet::Enable();
}

void AppCommonEnd(void)
{
    nn::hid::Finalize();
}

/*!--------------------------------------------------------*
 @brief  : nnMain()
 @param  : Ȃ
 @return : Ȃ
 @summary: fAvC
*----------------------------------------------------------*/
void nnMain()
{
    PRINT_OUT2("Demo Start\n");
    	
	AppCommonInit();

    OS_MEM_INIT();
    PRINT_OUT2("MEM_INIT OK\n");

    FILE_IO_INIT();
    PRINT_OUT2("FIL_IO_INIT OK\n");

#ifdef ENABLE_TIMESCALE
    OS_TICK_INIT();
    PRINT_OUT("OS_TICK_INIT OK\n");
#endif /* #ifdef ENABLE_TIMESCALE */

	// HWR s
    HWR_Main();

    UTILITY_TERM();
    FILE_IO_TERM();
    OS_MEM_TERM();
    AppCommonEnd();

    PRINT_OUT2("Demo End\n");

}
