/*--------------------------------------------------------------------------*
  Project:    HWR_Demo
  File:       hwr_sample.cpp

  Copyright (C) 2011 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/
#include "hwr_sample.h"
#include "hwr_wrap.h"

#ifdef __cplusplus
extern "C" {
#endif

extern InkInfo sample_ink_tbl[];
extern RegInkInfo regist_ink_tbl[];

/* t@CpX */
#define DIC_FILE_PATH  TEST_DATA_ROOT"dic/"

/* Ǘe[u */
static const DicInfo g_DicName[DIC_NUM_MAX]= {
    {"all2_u"                 ,DIC_FILE_PATH"all2_u.bin"                 }, /* S펫Qi{j              */
    {"all_u"                  ,DIC_FILE_PATH"all_u.bin"                  }, /* S펫i{j                */
    {"alnum_native_u"         ,DIC_FILE_PATH"alnum_native_u.bin"         }, /* piĐlj          */
    {"alnum_u"                ,DIC_FILE_PATH"alnum_u.bin"                }, /* p                        */
    {"alnumlat1_u"            ,DIC_FILE_PATH"alnumlat1_u.bin"            }, /* e1                       */
    {"alnumlat1_un"           ,DIC_FILE_PATH"alnumlat1_un.bin"           }, /* [}jA                    */
    {"dutch_u"                ,DIC_FILE_PATH"dutch_u.bin"                }, /* I_                      */
    {"french_u"               ,DIC_FILE_PATH"french_u.bin"               }, /* tX                      */
    {"german_u"               ,DIC_FILE_PATH"german_u.bin"               }, /* hCc                        */
    {"hangul_u"               ,DIC_FILE_PATH"hangul_u.bin"               }, /* nO                      */
    {"hira_u"                 ,DIC_FILE_PATH"hira_u.bin"                 }, /* Ђ炪Ȏ                      */
    {"hirakataalnum_u"        ,DIC_FILE_PATH"hirakataalnum_u.bin"        }, /* ЂJ^p                  */
    {"italian_u"              ,DIC_FILE_PATH"italian_u.bin"              }, /* C^A                      */
    {"kanji2_u"               ,DIC_FILE_PATH"kanji2_u.bin"               }, /* Q                        */
    {"kanji_u"                ,DIC_FILE_PATH"kanji_u.bin"                }, /* P                        */
    {"kata_u"                 ,DIC_FILE_PATH"kata_u.bin"                 }, /* J^Ji                      */
    {"korean_u"               ,DIC_FILE_PATH"korean_u.bin"               }, /* ؍                          */
    {"korean_un"              ,DIC_FILE_PATH"korean_un.bin"              }, /* ؍i؍QΉŁj*/
    {"portuguese_u"           ,DIC_FILE_PATH"portuguese_u.bin"           }, /* |gK                    */
    {"spanish_u"              ,DIC_FILE_PATH"spanish_u.bin"              }, /* XyC                      */


};

/* F[hǗe[u */
static const ModeInfo g_ModeType[MOD_NUM_MAX]= {
    {RMODE_ALL      ,0, "ALL"     }, /* SF                   */
    {RMODE_SYMBOL   ,0, "SYMBOL"  }, /* L                                 */
    {RMODE_NUMBER   ,0, "NUMBER"  }, /*   OPQRSTUVWX           */
    {RMODE_UALPHA   ,0, "UALPHA"  }, /* p啶 ``y                      */
    {RMODE_LALPHA   ,0, "LALPHA"  }, /* p `                      */
    {RMODE_HIRA     ,0, "HIRA"    }, /* Ђ炪 `            */
    {RMODE_KATA     ,0, "KATA"    }, /* J^Ji @A`      */
    {RMODE_GREEK    ,0, "GREEK"   }, /* MV                         */
    {RMODE_HANGUL   ,0, "HANGUL"  }, /* nO *//* VA 啶Ɠl  */
    {RMODE_HANJA    ,0, "HANJA"   }, /* ؍ *//* VA Ɠl  */
    {RMODE_KANJI1   ,0, "KANJI1"  }, /* JISP GB2312-80 ꋉ   */
    {RMODE_KANJI2   ,0, "KANJI2"  }  /* JISQ GB2312-80 񋉊   */
};

/* ID */
enum {
    DIC_TYPE_ALL2_U  = 0            ,  /* S펫Qi{j              */
    DIC_TYPE_ALL_U                  ,  /* S펫i{j                */
    DIC_TYPE_ALNUM_NATIVE_U         ,  /* piĐlj          */
    DIC_TYPE_ALNUM_U                ,  /* p                        */
    DIC_TYPE_ALNUMLAT1_U            ,  /* e1                       */
    DIC_TYPE_ALNUMLAT1_UN           ,  /* [}jA                    */
    DIC_TYPE_DUTCH_U                ,  /* I_                      */
    DIC_TYPE_FRENCH_U               ,  /* tX                      */
    DIC_TYPE_GERMAN_U               ,  /* hCc                        */
    DIC_TYPE_HANGUL_U               ,  /* nO                      */
    DIC_TYPE_HIRA_U                 ,  /* Ђ炪Ȏ                      */
    DIC_TYPE_HIRAKATAALNUM_U        ,  /* ЂJ^p                  */
    DIC_TYPE_ITALIAN_U              ,  /* C^A                      */
    DIC_TYPE_KANJI2_U               ,  /* Q                        */
    DIC_TYPE_KANJI_U                ,  /* P                        */
    DIC_TYPE_KATA_U                 ,  /* J^Ji                      */
    DIC_TYPE_KOREAN_U               ,  /* ؍                          */
    DIC_TYPE_KOREAN_UN              ,  /* ؍i؍QΉŁj*/
    DIC_TYPE_PORTUGUESE_U           ,  /* |gK                    */
    DIC_TYPE_SPANISH_U              ,  /* XyC                      */
    DIC_TYPE_MASTER
};


/*======================================================
 * O[oϐ Start
 *======================================================*/

/* f[^WJpobt@ */
unsigned char*    g_DicBuff;

/* MՃf[^ */
mw::hwr::HwrRecgData  g_RecgData;

bool gInitFlag = false;
/*======================================================
 * O[oϐ End
 *======================================================*/


/*!--------------------------------------------------------*
 @brief  : getDicName()
 @param  : index  e[uQƗpIndex
 @return : 
 @summary: 擾
*----------------------------------------------------------*/
char* getDicName(int index){
    return g_DicName[index].name;
}

/*!--------------------------------------------------------*
 @brief  : getModeName()
 @param  : index  e[uQƗpIndex
 @return : F[h
 @summary: F[h擾
*----------------------------------------------------------*/
char* getModeName(int index){
    return g_ModeType[index].name;
}

/*!--------------------------------------------------------*
 @brief  : getInkName()
 @param  : index  e[uQƗpIndex
 @return : MՃf[^
 @summary: MՃf[^擾
*----------------------------------------------------------*/
char* getInkName(int index){
    return sample_ink_tbl[index].comment;
}

/*!--------------------------------------------------------*
 @brief  : getInkCode()
 @param  : index  e[uQƗpIndex
 @return : MՃf[^̕R[h
 @summary: MՃf[^̕R[h擾
*----------------------------------------------------------*/
unsigned short getInkCode(int index){
    return sample_ink_tbl[index].ecode;
}

/*!--------------------------------------------------------*
 @brief  : getInkData()
 @param  : index  e[uQƗpIndex
 @return : MՃf[^ւ̃|C^
 @summary: MՃf[^擾
*----------------------------------------------------------*/
unsigned char* getInkData(int index){
    return (unsigned char*)sample_ink_tbl[index].pInk;
}


/*!--------------------------------------------------------*
 @brief  : getRegInkName()
 @param  : index  e[uQƗpIndex
 @return : MՃf[^
 @summary: MՃf[^擾
*----------------------------------------------------------*/
char* getRegInkName(int index, int type ){
    char* name=NULL;

    if( type == D_REG_CODE){
        name = regist_ink_tbl[index].RegCodeStr;

    } else if( type == D_ORG_CODE){
        name = regist_ink_tbl[index].OrgCodeStr;

    }else{
        name = NULL;
    }

    return name;
}

/*!--------------------------------------------------------*
 @brief  : getRegInkCode()
 @param  : index  e[uQƗpIndex
 @return : MՃf[^̕R[h
 @summary: MՃf[^̕R[h擾
*----------------------------------------------------------*/
unsigned short getRegInkCode(int index){
    return regist_ink_tbl[index].regEcode;
}

/*!--------------------------------------------------------*
 @brief  : getRegInkData()
 @param  : index  e[uQƗpIndex
 @return : MՃf[^ւ̃|C^
 @summary: MՃf[^擾
*----------------------------------------------------------*/
unsigned char* getRegInkData(int index){
    return (unsigned char*)regist_ink_tbl[index].pInk;
}

/*!--------------------------------------------------------*
 @brief  : getModeType()
 @param  : index  e[uQƗpIndex
 @return : F[h
 @summary: F[h擾
*----------------------------------------------------------*/
unsigned short getModeType(int index){
    return g_ModeType[index].type;
}

/*!--------------------------------------------------------*
 @brief  : hwrMW_Init()
 @param  : Ȃ
 @return : Ȃ
*----------------------------------------------------------*/
void hwrMW_Init( int dicIdx, unsigned char* pRegMem )
{

    short  libRet;
    FILE*  dicFp=NULL;
    long   dicDataSize=0;
    long   readSize=0;

//    PRINT_OUT("    hwrMW_Init() In\n");
    /*---------------------------------
     * O[oϐ
     *---------------------------------*/
    g_DicBuff = NULL;                                /* f[^WJobt@ */
    memset( &g_RecgData, 0, sizeof(mw::hwr::HwrRecgData) );     /* RT_Exec()ƂI/Ff[^   */


    /*---------------------------------
     * f[^WJ
     *---------------------------------*/
    /* t@CI[v */
    dicFp = FILE_OPEN( g_DicName[dicIdx].fileName, "rb" );
    if( dicFp == NULL ){
        PRINT_OUT("    [Error] %s dicfile Open Error.\n", g_DicName[dicIdx].fileName );
        goto ERROR_END;
    }
    
    /* t@CTCY擾 */
    dicDataSize = FILE_GETSIZE( dicFp );
    if( dicDataSize <= 0 ){
        PRINT_OUT("    [Error] %s dic size <= 0\n", dicDataSize );
        goto ERROR_END;
    }    

    /* f[^WJpobt@̎擾 */
    g_DicBuff = (unsigned char*)OS_MALLOC_EX( D_MATH_ROUNDUP(dicDataSize,D_FILE_IO_ALIGNMENT), D_FILE_IO_ALIGNMENT );
    if( g_DicBuff == NULL ){
        PRINT_OUT("    [Error] %s dic buffer alloc Error\n", g_DicName[dicIdx].name );
        goto ERROR_END;
    }
    
    /* f[^WJ */
    readSize = (long)FILE_READ( g_DicBuff, 1, dicDataSize , dicFp );
    if( readSize != dicDataSize ){
        PRINT_OUT("    [Error] %s dicfile Read Error.\n", g_DicName[dicIdx].fileName );
        goto ERROR_END;
    }
    
    /* t@CN[Y */
    if( dicFp ){
        FILE_CLOSE( dicFp );
        dicFp = NULL;
    }

    /*---------------------------------
     * HWRCu
     *---------------------------------*/
    libRet = WRAP_RecogInitialize( HWR_WAKU_W, HWR_WAKU_H, g_DicBuff );
    if( libRet != RT_OK ){
        PRINT_OUT("    [Error] RT_Init() error = %d\n", libRet );
        goto ERROR_END;
    }

    libRet = WRAP_RegisterInitialize( INK_NUM_MAX, pRegMem );
    if( libRet != RT_OK ){
        PRINT_OUT("    [Error] RT_Register_Init() error = %d\n", libRet );
        goto ERROR_END;
    }

    gInitFlag = true;
    PRINT_OUT("    hwrMW_Init() Out Success.\n");
    return;

ERROR_END:
    if( dicFp ){
        FILE_CLOSE( dicFp );
        dicFp = NULL;
    }
    if( g_DicBuff ){
        OS_FREE( g_DicBuff );
        g_DicBuff = NULL;
    }
    PRINT_OUT("    hwrMW_Init() Out Failed.\n");
    return;
}


/*!--------------------------------------------------------*
 @brief  : hwrMW_End()
 @param  : Ȃ
 @return : Ȃ
 @summery: HWRCuI
*----------------------------------------------------------*/
void hwrMW_End( void )
{
    short  libRet;

    PRINT_OUT("    hwrMW_End() In.\n");

    if( gInitFlag ){
        libRet = WRAP_RegisterFinalize();
        if( libRet != RT_OK ){
            PRINT_OUT("    [Error] RT_Register_Term() error = %d\n", libRet );
            // Through
        }

        libRet = WRAP_RecogFinalize();
        if( libRet != RT_OK ){
            PRINT_OUT("    [Error] RT_Term() error = %d\n", libRet );
        }
    }
    gInitFlag = false;
    /*---------------------------------
     * eI
     *---------------------------------*/
    if( g_DicBuff ){
        OS_FREE( g_DicBuff );
        g_DicBuff = NULL;
    }


    PRINT_OUT("    hwrMW_End() Out.\n");
    return;

}

/*!--------------------------------------------------------*
 @brief  : hwrMW_Exec()
 @param  : modeIdx  e[uQƗpIndexiF[hǗj
 @param  : inkIdx   e[uQƗpIndexiMՃf[^Ǘj
 @return : Ȃ
 @summary: 菑F̃eXg֐
*----------------------------------------------------------*/
void hwrMW_Exec( int modeIdx, int inkIdx, bool rMode )
{
    int i;
    short  libRet;
    long   inkDataSize=0;
    int    modeType;

    unsigned short  code[ DLL_REGISTER_CNADI ];
    unsigned short  score[ DLL_REGISTER_CNADI ];

    memset( code, 0, sizeof(code) );
    memset( score, 0, sizeof(score) );

    /*---------------------------------
     * HWRCuF[hݒ
     *---------------------------------*/
    modeType = g_ModeType[modeIdx].type;


    libRet = WRAP_RecogChangeMode( (unsigned short)modeType);
    if( libRet != RT_OK ){
        PRINT_OUT("    [Error] RT_Mode() error = %d\n", libRet );
        // Through
    }

    
    /*---------------------------------
     * HWRCuF
     *---------------------------------*/
    //MՃf[^ݒ
    strcpy( (char *)g_RecgData.idat, (const char *)sample_ink_tbl[inkIdx].pInk );
    
    /* MՂ̃f[^擾 */
    inkDataSize = (long)strlen( (const char *)sample_ink_tbl[inkIdx].pInk );
    
    /* I_f[^ݒ */
    g_RecgData.idat[inkDataSize + 0]=0xFF;
    g_RecgData.idat[inkDataSize + 1]=0xFF;
    
    libRet = WRAP_RecogExecute( &g_RecgData );
    if( libRet == RT_NG ){
        PRINT_OUT("    [Error] RT_Mode() error = %d\n", libRet );
    }

    /* Fʏo */
    for( i = 0; i < libRet; i++ ){
        PRINT_OUT( "     [Exec] Unicode:0x%04X (%d)\n", g_RecgData.moji[i], g_RecgData.deg[i] );
    }

    PRINT_OUT("\n");

    if( libRet > 0 && rMode ){

        libRet = WRAP_RegisterResult( code, score );
        if( libRet != RT_NG ){
            for( i=0; i<libRet; i++ ){
                PRINT_OUT( "      [Reg ] Unicode:0x%04X (%d)\n", code[i], score[i] );
            }
        }
    }

    return;
}


#ifdef __cplusplus
}
#endif
/*---------------------------------------------------------------------------*
  End of file
 *---------------------------------------------------------------------------*/

