/*--------------------------------------------------------------------------*
  Project:    HWR_Demo
  File:       hwr_wrap.cpp

  Copyright (C) 2011 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/
/******************************************************************
            include t@C
*******************************************************************/
#include "hwr_sample.h"

#ifdef __cplusplus
extern "C" {
#endif /* #ifdef __cplusplus */

/*!--------------------------------------------------------*
 @brief  : WRAP_RecogInitialize()
 @param  : Ȃ
 @return : Ȃ
 @summery: HWRCuI
*----------------------------------------------------------*/
short WRAP_RecogInitialize( short fsizeX, short fsizeY, unsigned char *spath )
{
    short libRet;
#ifdef ENABLE_TIMESCALE    
    OS_TICK             tx[2];
    tx[0]=tx[1]=0;
#endif /* #ifdef ENABLE_TIMESCALE */

#ifdef ENABLE_TIMESCALE
tx[0] = OS_GET_TICK();
#endif /* #ifdef ENABLE_TIMESCALE */

    libRet = mw::hwr::Initialize( fsizeX, fsizeY, spath );

#ifdef ENABLE_TIMESCALE
tx[1] = OS_GET_TICK();
    PRINT_OUT("    RT_Init() : %ld %s \n", OS_TICKS_TO_MSEC(tx[1]-tx[0]), TIME_UNIT);
#endif /* #ifdef ENABLE_TIMESCALE */

    return libRet;
}

/*!--------------------------------------------------------*
 @brief  : WRAP_RecogFinalize()
 @param  : Ȃ
 @return : Ȃ
 @summery: HWRCuI
*----------------------------------------------------------*/
short WRAP_RecogFinalize( void )
{
    short libRet;
#ifdef ENABLE_TIMESCALE    
    OS_TICK             tx[2];
    tx[0]=tx[1]=0;
#endif /* #ifdef ENABLE_TIMESCALE */

#ifdef ENABLE_TIMESCALE
tx[0] = OS_GET_TICK();
#endif /* #ifdef ENABLE_TIMESCALE */

    libRet = mw::hwr::Finalize();

#ifdef ENABLE_TIMESCALE
tx[1] = OS_GET_TICK();
    PRINT_OUT("    RT_Term() : %ld %s \n", OS_TICKS_TO_MSEC(tx[1]-tx[0]), TIME_UNIT);
#endif /* #ifdef ENABLE_TIMESCALE */

    return libRet;
}

/*!--------------------------------------------------------*
 @brief  : WRAP_RecogExecute()
 @param  : Ȃ
 @return : Ȃ
 @summery: HWRCuI
*----------------------------------------------------------*/
short WRAP_RecogExecute( mw::hwr::HwrRecgData *rdata )
{
    short libRet;
#ifdef ENABLE_TIMESCALE
    OS_TICK             tx[2];
    tx[0]=tx[1]=0;
#endif /* #ifdef ENABLE_TIMESCALE */

#ifdef ENABLE_TIMESCALE
tx[0] = OS_GET_TICK();
#endif /* #ifdef ENABLE_TIMESCALE */

    libRet = mw::hwr::Execute( rdata );

#ifdef ENABLE_TIMESCALE
tx[1] = OS_GET_TICK();
    PRINT_OUT("    RT_Exec() : %ld %s \n", OS_TICKS_TO_MSEC(tx[1]-tx[0]), TIME_UNIT);
#endif /* #ifdef ENABLE_TIMESCALE */

    return libRet;
}

/*!--------------------------------------------------------*
 @brief  : WRAP_RecogChangeMode()
 @param  : Ȃ
 @return : Ȃ
 @summery: HWRCuI
*----------------------------------------------------------*/
short WRAP_RecogChangeMode( unsigned short rmode )
{
    short libRet;
#ifdef ENABLE_TIMESCALE    
    OS_TICK             tx[2];
    tx[0]=tx[1]=0;
#endif /* #ifdef ENABLE_TIMESCALE */

#ifdef ENABLE_TIMESCALE
tx[0] = OS_GET_TICK();
#endif /* #ifdef ENABLE_TIMESCALE */

    libRet = mw::hwr::ChangeMode( rmode );

#ifdef ENABLE_TIMESCALE
tx[1] = OS_GET_TICK();
    PRINT_OUT("    RT_Mode() : %ld %s \n", OS_TICKS_TO_MSEC(tx[1]-tx[0]), TIME_UNIT);
#endif /* #ifdef ENABLE_TIMESCALE */
    return libRet;

}

/*!--------------------------------------------------------*
 @brief  : WRAP_RegisterInitialize()
 @param  : Ȃ
 @return : Ȃ
 @summery: o^@\̏
*----------------------------------------------------------*/
short WRAP_RegisterInitialize( unsigned short count, unsigned char *RegDicMem )
{
    short libRet;
#ifdef ENABLE_TIMESCALE    
    OS_TICK             tx[2];
    tx[0]=tx[1]=0;
#endif /* #ifdef ENABLE_TIMESCALE */

#ifdef ENABLE_TIMESCALE
tx[0] = OS_GET_TICK();
#endif /* #ifdef ENABLE_TIMESCALE */

    libRet = mw::hwr::RegisterInitialize( count, RegDicMem );

#ifdef ENABLE_TIMESCALE
tx[1] = OS_GET_TICK();
    PRINT_OUT("    RT_Register_Init() : %ld %s \n", OS_TICKS_TO_MSEC(tx[1]-tx[0]), TIME_UNIT);
#endif /* #ifdef ENABLE_TIMESCALE */

    return libRet;
}

/*!--------------------------------------------------------*
 @brief  : WRAP_RegisterFinalize()
 @param  : Ȃ
 @return : Ȃ
 @summery: o^@\̏I
*----------------------------------------------------------*/
short WRAP_RegisterFinalize(void )
{
    short libRet;
#ifdef ENABLE_TIMESCALE    
    OS_TICK             tx[2];
    tx[0]=tx[1]=0;
#endif /* #ifdef ENABLE_TIMESCALE */

#ifdef ENABLE_TIMESCALE
tx[0] = OS_GET_TICK();
#endif /* #ifdef ENABLE_TIMESCALE */

    libRet = mw::hwr::RegisterFinalize();

#ifdef ENABLE_TIMESCALE
tx[1] = OS_GET_TICK();
    PRINT_OUT("    RT_Register_Term() : %ld %s \n", OS_TICKS_TO_MSEC(tx[1]-tx[0]), TIME_UNIT);
#endif /* #ifdef ENABLE_TIMESCALE */

    return libRet;
}

/*!--------------------------------------------------------*
 @brief  : WRAP_RegisterSet()
 @param  : Ȃ
 @return : Ȃ
 @summery: o^̐ݒ
*----------------------------------------------------------*/
short WRAP_RegisterSet (unsigned short ecode, unsigned char *idat)
{
    short libRet;
#ifdef ENABLE_TIMESCALE    
    OS_TICK             tx[2];
    tx[0]=tx[1]=0;
#endif /* #ifdef ENABLE_TIMESCALE */

#ifdef ENABLE_TIMESCALE
tx[0] = OS_GET_TICK();
#endif /* #ifdef ENABLE_TIMESCALE */

    libRet = mw::hwr::RegisterSet( ecode, idat );

#ifdef ENABLE_TIMESCALE
tx[1] = OS_GET_TICK();
    PRINT_OUT("    RT_Register_Set() : %ld %s \n", OS_TICKS_TO_MSEC(tx[1]-tx[0]), TIME_UNIT);
#endif /* #ifdef ENABLE_TIMESCALE */

    return libRet;
}

/*!--------------------------------------------------------*
 @brief  : WRAP_RegisterResult()
 @param  : Ȃ
 @return : Ȃ
 @summery: o^ł̔Fsʎ擾
*----------------------------------------------------------*/
short WRAP_RegisterResult (unsigned short *ecode, unsigned short *deg)
{
    short libRet;
#ifdef ENABLE_TIMESCALE    
    OS_TICK             tx[2];
    tx[0]=tx[1]=0;
#endif /* #ifdef ENABLE_TIMESCALE */

#ifdef ENABLE_TIMESCALE
tx[0] = OS_GET_TICK();
#endif /* #ifdef ENABLE_TIMESCALE */

    libRet = mw::hwr::RegisterResult( ecode, deg );

#ifdef ENABLE_TIMESCALE
tx[1] = OS_GET_TICK();
    PRINT_OUT("    RT_Register_Result() : %ld %s \n", OS_TICKS_TO_MSEC(tx[1]-tx[0]), TIME_UNIT);
#endif /* #ifdef ENABLE_TIMESCALE */

    return libRet;
}

/*!--------------------------------------------------------*
 @brief  : WRAP_RegisterDelete()
 @param  : Ȃ
 @return : Ȃ
 @summery: o^ς݂̕폜
*----------------------------------------------------------*/
short WRAP_RegisterDelete (unsigned short ecode)
{
    short libRet;
#ifdef ENABLE_TIMESCALE    
    OS_TICK             tx[2];
    tx[0]=tx[1]=0;
#endif /* #ifdef ENABLE_TIMESCALE */

#ifdef ENABLE_TIMESCALE
tx[0] = OS_GET_TICK();
#endif /* #ifdef ENABLE_TIMESCALE */

    libRet = mw::hwr::RegisterDelete( ecode );

#ifdef ENABLE_TIMESCALE
tx[1] = OS_GET_TICK();
    PRINT_OUT("    RT_Init() : %ld %s \n", OS_TICKS_TO_MSEC(tx[1]-tx[0]), TIME_UNIT);
#endif /* #ifdef ENABLE_TIMESCALE */

    return libRet;
}

/*!--------------------------------------------------------*
 @brief  : WRAP_RegisterInfo()
 @param  : Ȃ
 @return : Ȃ
 @summery: o^ς݂̕擾
*----------------------------------------------------------*/
short WRAP_RegisterInfo (unsigned short *ecode)
{
    short libRet;
#ifdef ENABLE_TIMESCALE    
    OS_TICK             tx[2];
    tx[0]=tx[1]=0;
#endif /* #ifdef ENABLE_TIMESCALE */

#ifdef ENABLE_TIMESCALE
tx[0] = OS_GET_TICK();
#endif /* #ifdef ENABLE_TIMESCALE */

    libRet = mw::hwr::RegisterInfo( ecode );

#ifdef ENABLE_TIMESCALE
tx[1] = OS_GET_TICK();
    PRINT_OUT("    RT_Register_Info() : %ld %s \n", OS_TICKS_TO_MSEC(tx[1]-tx[0]), TIME_UNIT);
#endif /* #ifdef ENABLE_TIMESCALE */

    return libRet;
}
#ifdef __cplusplus
}
#endif /* #ifdef __cplusplus */

