/*--------------------------------------------------------------------------*
  Project:    HWR_Demo
  File:       sample_inkdata.c

  Copyright (C) 2011 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/
#include "hwr_sample.h"

/* TvMՃf[^ 'O'ij */
static const unsigned char defdat_U0030_num[] = {
/*    xW yW    */
    0x9c, 0x16, /* 1  y_EJn */
    0x9b, 0x17,
    0x9a, 0x19,
    0x99, 0x1b,
    0x98, 0x1d,
    0x97, 0x20,
    0x95, 0x24,
    0x94, 0x27,
    0x93, 0x2b,
    0x93, 0x2e,
    0x93, 0x31,
    0x94, 0x32,
    0x96, 0x32,
    0x99, 0x31,
    0x9b, 0x2f,
    0x9e, 0x2c,
    0x9f, 0x29,
    0xa0, 0x26,
    0xa0, 0x22,
    0xa0, 0x1f,
    0xa0, 0x1c,
    0x9f, 0x1a,
    0x9e, 0x18,
    0x9d, 0x17,
    0x1c, 0x16,
    0x00, 0x00
};


/* TvMՃf[^ '`'ip啶j */
static const unsigned char defdat_U0041_ual[] = {
/*    xW yW    */
    0xa0, 0x0c, /* 1  y_EJn */
    0x0d, 0x36,
    0xa0, 0x0c, /* 2  y_EJn */
    0x34, 0x37,
    0x95, 0x24, /* 3  y_EJn */
    0x2a, 0x24,
    0x00, 0x00
};


/* TvMՃf[^ ''ipj */
static const unsigned char defdat_U0061_lal[] = {
/*    xW yW    */
    0xa8, 0x18, /* 1  y_EJn */
    0xa6, 0x12,
    0x9b, 0x0d,
    0x90, 0x12,
    0x85, 0x26,
    0x85, 0x31,
    0x87, 0x35,
    0x8b, 0x37,
    0xab, 0x21,
    0xaa, 0x1d,
    0xa9, 0x19,
    0x31, 0x39,
    0x00, 0x00
};


/* TvMՃf[^ ''iMVA啶j */
static const unsigned char defdat_U03a9_ugr[] = {
/*    xW yW    */
    0x88, 0x32, /* 1  y_EJn */
    0x96, 0x32,
    0x8a, 0x22,
    0x92, 0x13,
    0xa1, 0x0a,
    0xae, 0x11,
    0xb7, 0x22,
    0xaa, 0x32,
    0x38, 0x32,
    0x00, 0x00
};


/* TvMՃf[^ ''iMVAj */
static const unsigned char defdat_U03b1_lgr[] = {
/*    xW yW    */
    0xaf, 0x11, /* 1  y_EJn */
    0xae, 0x11,
    0xae, 0x12,
    0xae, 0x13,
    0xad, 0x13,
    0xac, 0x14,
    0xac, 0x15,
    0xab, 0x16,
    0xaa, 0x17,
    0xa9, 0x18,
    0xa9, 0x19,
    0xa8, 0x1a,
    0xa7, 0x1b,
    0xa7, 0x1c,
    0xa6, 0x1d,
    0xa6, 0x1e,
    0xa5, 0x1f,
    0xa4, 0x20,
    0xa3, 0x22,
    0xa2, 0x22,
    0xa2, 0x23,
    0xa2, 0x24,
    0xa1, 0x24,
    0xa1, 0x25,
    0xa0, 0x26,
    0x9f, 0x27,
    0x9e, 0x27,
    0x9d, 0x28,
    0x9d, 0x29,
    0x9c, 0x29,
    0x9c, 0x2a,
    0x9b, 0x2b,
    0x99, 0x2b,
    0x99, 0x2c,
    0x98, 0x2c,
    0x97, 0x2d,
    0x96, 0x2d,
    0x96, 0x2e,
    0x95, 0x2e,
    0x94, 0x2e,
    0x93, 0x2e,
    0x93, 0x2f,
    0x92, 0x2f,
    0x91, 0x30,
    0x90, 0x30,
    0x8f, 0x30,
    0x8e, 0x30,
    0x8d, 0x30,
    0x8c, 0x30,
    0x8b, 0x30,
    0x8a, 0x30,
    0x88, 0x30,
    0x87, 0x2f,
    0x87, 0x2e,
    0x86, 0x2d,
    0x86, 0x2c,
    0x85, 0x2b,
    0x85, 0x2a,
    0x85, 0x29,
    0x85, 0x28,
    0x84, 0x27,
    0x84, 0x26,
    0x84, 0x25,
    0x84, 0x24,
    0x84, 0x23,
    0x84, 0x22,
    0x84, 0x21,
    0x84, 0x20,
    0x85, 0x20,
    0x85, 0x1f,
    0x85, 0x1e,
    0x86, 0x1d,
    0x86, 0x1c,
    0x86, 0x1b,
    0x87, 0x1b,
    0x88, 0x1a,
    0x88, 0x19,
    0x89, 0x19,
    0x8a, 0x18,
    0x8b, 0x18,
    0x8c, 0x16,
    0x8e, 0x15,
    0x8f, 0x15,
    0x90, 0x15,
    0x91, 0x15,
    0x92, 0x14,
    0x93, 0x14,
    0x94, 0x14,
    0x95, 0x14,
    0x96, 0x14,
    0x97, 0x14,
    0x98, 0x14,
    0x98, 0x15,
    0x99, 0x15,
    0x9a, 0x16,
    0x9b, 0x16,
    0x9b, 0x17,
    0x9c, 0x17,
    0x9c, 0x18,
    0x9d, 0x19,
    0x9e, 0x19,
    0x9e, 0x1a,
    0x9f, 0x1a,
    0x9f, 0x1b,
    0x9f, 0x1c,
    0x9f, 0x1d,
    0x9f, 0x1e,
    0xa0, 0x1e,
    0xa0, 0x1f,
    0xa0, 0x20,
    0xa0, 0x21,
    0xa0, 0x22,
    0xa1, 0x22,
    0xa1, 0x23,
    0xa1, 0x24,
    0xa2, 0x24,
    0xa2, 0x25,
    0xa2, 0x26,
    0xa2, 0x27,
    0xa3, 0x27,
    0xa3, 0x28,
    0xa4, 0x29,
    0xa4, 0x2a,
    0xa5, 0x2a,
    0xa5, 0x2b,
    0xa6, 0x2b,
    0xa6, 0x2c,
    0xa7, 0x2c,
    0xa7, 0x2d,
    0xa8, 0x2d,
    0xa9, 0x2d,
    0xa9, 0x2e,
    0xaa, 0x2e,
    0xab, 0x2e,
    0xac, 0x2e,
    0xad, 0x2e,
    0xae, 0x2e,
    0xaf, 0x2e,
    0xb0, 0x2e,
    0x30, 0x2e,
    0x00, 0x00
};


/* TvMՃf[^ 'A' iLj */
static const unsigned char defdat_U3001_sym[] = {
/*    xW yW    */
    0x91, 0x1b, /* 1  y_EJn */
    0x92, 0x1b,
    0x93, 0x1b,
    0x94, 0x1c,
    0x95, 0x1c,
    0x96, 0x1d,
    0x97, 0x1e,
    0x98, 0x1f,
    0x99, 0x20,
    0x9a, 0x21,
    0x9c, 0x23,
    0x9d, 0x24,
    0x9e, 0x26,
    0x9f, 0x28,
    0xa0, 0x29,
    0xa0, 0x2a,
    0xa1, 0x2b,
    0xa2, 0x2c,
    0xa3, 0x2d,
    0xa4, 0x2e,
    0x24, 0x2e,
    0x00, 0x00
};


/* TvMՃf[^ ''iЂ炪ȁj */
static const unsigned char defdat_U3042_hira[] = {
/*    xW yW    */
    0x92, 0x17, /* 1  y_EJn */
    0x28, 0x11,
    0x9e, 0x0a, /* 2  y_EJn */
    0x1b, 0x38,
    0xa7, 0x1b, /* 3  y_EJn */
    0x92, 0x33,
    0x91, 0x28,
    0xa8, 0x24,
    0xad, 0x30,
    0x29, 0x36,
    0x00, 0x00
};


/* TvMՃf[^ 'A' iJ^Jij */
static const unsigned char defdat_U30a2_kata[] = {
/*    xW yW    */
    0x89, 0x13, /* 1  y_EJn */
    0xb1, 0x13,
    0x2b, 0x1b,
    0x9e, 0x1c, /* 2  y_EJn */
    0x9c, 0x32,
    0x16, 0x3d,
    0x00, 0x00
};


/* TvMՃf[^ '' iJISPj */
static const unsigned char defdat_U4e9c_kj1[] = {
/*    xW yW    */
    0x8f, 0x0f, /* 1  y_EJn */
    0x31, 0x0e,
    0x8e, 0x18, /* 2  y_EJn */
    0x12, 0x2c,
    0x90, 0x1c, /* 3  y_EJn */
    0xb3, 0x1b,
    0x2c, 0x2d,
    0x94, 0x2a, /* 4  y_EJn */
    0x2b, 0x2a,
    0x9c, 0x13, /* 5  y_EJn */
    0x1c, 0x36,
    0xa4, 0x14, /* 6  y_EJn */
    0x22, 0x38,
    0x88, 0x39, /* 7  y_EJn */
    0x38, 0x39,
    0x00, 0x00
};


/* TvMՃf[^ '' iJISQj */
static const unsigned char defdat_U5f0c_kj2[] = {
/*    xW yW    */
    0x8c, 0x1b, /* 1  y_EJn */
    0x33, 0x15,
    0x94, 0x2b, /* 2  y_EJn */
    0x24, 0x28,
    0xa3, 0x0a, /* 3  y_EJn */
    0xb7, 0x3e,
    0x38, 0x30,
    0xb2, 0x0b, /* 4  y_EJn */
    0x36, 0x10,
    0x00, 0x00
};


/* TvMՃf[^ 'b'i؍j */
static const unsigned char defdat_U9240_Hanja[] = {
/*    xW yW    */
    0x97, 0x08, /* 1  y_EJn */
    0x8e, 0x18,
    0x02, 0x24,
    0x97, 0x0a, /* 2  y_EJn */
    0x1e, 0x17,
    0x90, 0x19, /* 3  y_EJn */
    0x1a, 0x18,
    0x90, 0x20, /* 4  y_EJn */
    0x1a, 0x1f,
    0x94, 0x19, /* 5  y_EJn */
    0x14, 0x30,
    0x8c, 0x2e, /* 6  y_EJn */
    0x10, 0x32,
    0x9b, 0x2b, /* 7  y_EJn */
    0x18, 0x30,
    0x89, 0x36, /* 8  y_EJn */
    0x1e, 0x2e,
    0x9f, 0x0b, /* 9  y_EJn */
    0x22, 0x1f,
    0xa1, 0x0e, /* 10  y_EJn */
    0xb9, 0x0b,
    0x37, 0x20,
    0xa2, 0x16, /* 11  y_EJn */
    0x38, 0x13,
    0xa3, 0x1e, /* 12  y_EJn */
    0x37, 0x1c,
    0xac, 0x0e, /* 13  y_EJn */
    0x2c, 0x3f,
    0x00, 0x00
};


/* TvMՃf[^ 'tg'inOj */
static const unsigned char defdat_Uac00_hangul[] = {
/*    xW yW    */
    0x8a, 0x20, /* 1  y_EJn */
    0x9b, 0x1e,
    0x11, 0x31,
    0xa4, 0x14, /* 2  y_EJn */
    0x24, 0x3a,
    0xa5, 0x26, /* 3  y_EJn */
    0x33, 0x28,
    0x00, 0x00
};


/* TvMՃf[^ '`' iLj*/
static const unsigned char defdat_U042f_uCyrillic[] = {
/*    xW yW    */
    0xa5, 0x0c,
    0x25, 0x35,
    0xa4, 0x0c,
    0x9a, 0x0c,
    0x95, 0x0f,
    0x95, 0x17,
    0x9a, 0x1c,
    0xa4, 0x1c,
    0x12, 0x34,
    0xff, 0xff,
    0x00, 0x00
};

/* TvMՃf[^ 'C' ij*/
/*
  {JIS3mFpMՃf[^łAȑ̎Aɑ̎
    ^Ă邽ߎgp܂Ball2ɂ͖^j
*/
static const unsigned char defdat_U4ee1_kj3[] = {
/*    xW yW    */
    0xa3, 0x1d,
    0xa1, 0x23,
    0x9f, 0x27,
    0x9d, 0x2b,
    0x9b, 0x2f,
    0x99, 0x33,
    0x96, 0x36,
    0x94, 0x3a,
    0x11, 0x3e,
    0x9c, 0x2b,
    0x9d, 0x2f,
    0x9e, 0x33,
    0x9e, 0x37,
    0x9f, 0x3d,
    0x9f, 0x40,
    0xa0, 0x46,
    0xa0, 0x4c,
    0xa0, 0x52,
    0x20, 0x55,
    0xb8, 0x18,
    0xb7, 0x1b,
    0xb5, 0x20,
    0xb3, 0x24,
    0x31, 0x29,
    0xb4, 0x21,
    0xb7, 0x22,
    0xbd, 0x22,
    0xc2, 0x21,
    0xc7, 0x21,
    0xcb, 0x21,
    0x51, 0x21,
    0xb3, 0x2f,
    0xb8, 0x2f,
    0xbd, 0x2e,
    0xc3, 0x2d,
    0xc7, 0x2c,
    0xcb, 0x2b,
    0xd1, 0x2a,
    0xcd, 0x2b,
    0xc7, 0x31,
    0xc3, 0x34,
    0xbe, 0x38,
    0xb8, 0x3c,
    0xb5, 0x42,
    0xb4, 0x47,
    0xb4, 0x4c,
    0xba, 0x4e,
    0xbf, 0x4d,
    0xc3, 0x4d,
    0xc8, 0x4c,
    0xcc, 0x4b,
    0xd1, 0x49,
    0x52, 0x44,
    0xff, 0xff,
    0x00, 0x00
};



/* TvMՃf[^Ǘe[u */
InkInfo sample_ink_tbl[] = {
     { 0x0030, {0x00,0x00}, "U-0030", defdat_U0030_num      }            /* 'O'                     */
    ,{ 0x0041, {0x00,0x00}, "U-0041", defdat_U0041_ual      }            /* '`'    At@xbg啶 */
    ,{ 0x0061, {0x00,0x00}, "U-0061", defdat_U0061_lal      }            /* ''    At@xbg */
    ,{ 0x03a9, {0x00,0x00}, "U-03a9", defdat_U03a9_ugr      }            /* ''    MVA             */
    ,{ 0x03b1, {0x00,0x00}, "U-03b1", defdat_U03b1_lgr      }            /* ''    MVA             */
    ,{ 0x3001, {0x00,0x00}, "U-3001", defdat_U3001_sym      }            /* 'A'    L                 */
    ,{ 0x3042, {0x00,0x00}, "U-3042", defdat_U3042_hira     }            /* ''    Ђ炪             */
    ,{ 0x30a2, {0x00,0x00}, "U-30a2", defdat_U30a2_kata     }            /* 'A'    J^Ji             */
    ,{ 0x4e9c, {0x00,0x00}, "U-4e9c", defdat_U4e9c_kj1      }            /* ''    P             */
    ,{ 0x5f0c, {0x00,0x00}, "U-5f0c", defdat_U5f0c_kj2      }            /* ''    Q             */
    ,{ 0x9240, {0x00,0x00}, "U-9240", defdat_U9240_Hanja    }            /* 'b'  ؍             */
    ,{ 0xac00, {0x00,0x00}, "U-ac00", defdat_Uac00_hangul   }            /* 'tg'  nO             */
    ,{ 0x042f, {0x00,0x00}, "U-042f", defdat_U042f_uCyrillic}            /* '`'    L             */
    ,{ 0x4ee1, {0x00,0x00}, "U-4ee1", defdat_U4ee1_kj3      }            /* 'C'                   */
};


/* o^pTvMՃf[^Ǘe[u */
RegInkInfo regist_ink_tbl[] = {
     { 0xE000, {0x00,0x00}, "0xE000", "U-0030", defdat_U0030_num      }   /* 'O'                     */
    ,{ 0xE001, {0x00,0x00}, "0xE001", "U-0041", defdat_U0041_ual      }   /* '`'    At@xbg啶 */
    ,{ 0xE002, {0x00,0x00}, "0xE002", "U-0061", defdat_U0061_lal      }   /* ''    At@xbg */
    ,{ 0xE303, {0x00,0x00}, "0xE303", "U-03a9", defdat_U03a9_ugr      }   /* ''    MVA             */
    ,{ 0xE304, {0x00,0x00}, "0xE304", "U-03b1", defdat_U03b1_lgr      }   /* ''    MVA             */
    ,{ 0xE005, {0x00,0x00}, "0xE005", "U-3001", defdat_U3001_sym      }   /* 'A'    L                 */
    ,{ 0xE006, {0x00,0x00}, "0xE006", "U-3042", defdat_U3042_hira     }   /* ''    Ђ炪             */
    ,{ 0xE007, {0x00,0x00}, "0xE007", "U-30a2", defdat_U30a2_kata     }   /* 'A'    J^Ji             */
    ,{ 0xE008, {0x00,0x00}, "0xE008", "U-4e9c", defdat_U4e9c_kj1      }   /* ''    P             */
    ,{ 0xE009, {0x00,0x00}, "0xE009", "U-5f0c", defdat_U5f0c_kj2      }   /* ''    Q             */
    ,{ 0xE00A, {0x00,0x00}, "0xE00A", "U-9240", defdat_U9240_Hanja    }   /* 'b'  ؍             */
    ,{ 0xE00B, {0x00,0x00}, "0xE00B", "U-ac00", defdat_Uac00_hangul   }   /* 'tg'  nO             */
    ,{ 0xE00C, {0x00,0x00}, "0xE00C", "U-042f", defdat_U042f_uCyrillic}   /* '`'    L             */
    ,{ 0xE00D, {0x00,0x00}, "0xE00D", "U-4ee1", defdat_U4ee1_kj3      }   /* 'C'                   */
};

