/*-----------------------------------------------------------------------*
 Project: [HWR_GuiSample]
 File: [hwr_font.h]

 Copyright (C) 2011 Nintendo Co., Ltd. All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law. They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
*-----------------------------------------------------------------------*/
#ifndef _HWR_FONT_H_
#define _HWR_FONT_H_

#ifdef __cplusplus
//extern "C" {
#endif


/******************************************************************
                        include t@C
*******************************************************************/
#include <nn/types.h>
#include <nn/os.h>
#include <nn/font.h>
using namespace nn::os;
using namespace nn::font;

typedef u16 CODE_SIZE;

/******************************************************************
            OJ֐
*******************************************************************/
void* InitShaders(nn::font::RectDrawer* pDrawer);
void InitDraw( int width, int height );
void ResetDraw( void );
bool InitFont( nn::font::ResFont*  pFont );
void CleanupFont(nn::font::ResFont* pFont);
nn::font::DispStringBuffer* AllocDispStringBuffer(int charMax);
void SetupTextCamera( nn::font::RectDrawer* pDrawer, int width, int height );
void DrawTextWithFontResult( nn::font::RectDrawer* pDrawer, nn::font::DispStringBuffer* pDrawStringBuf, nn::font::ResFont* pFont, CODE_SIZE* pList, int num );
void DrawTextWithFont( nn::font::RectDrawer* pDrawer, nn::font::DispStringBuffer* pDrawStringBuf,nn::font::ResFont* pFont, char* pString );
void DrawText( nn::font::RectDrawer* pDrawer, nn::font::DispStringBuffer* pDrawStringBuf, nn::font::ResFont* pFont, char* pString, int x, int y );

#ifdef __cplusplus
//}
#endif
#endif /* #ifndef _HWR_FONT_H_ */
