/*-----------------------------------------------------------------------*
 Project: [HWR_GuiSample]
 File: [main.cpp]

 Copyright (C) 2011 Nintendo Co., Ltd. All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law. They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
*-----------------------------------------------------------------------*/
/******************************************************************
                        include t@C
*******************************************************************/
#include <nn.h>
#include <demo.h>
#include "hwr_mw.h"
//#include "CCtrlGraphics.h"
#include "CtrlGraphics.h"
#include "hwr_font.h"
#include <wchar.h>

const int MAX_POINTS_OF_CHAR   = DLL_SEND_INKS;     // 1ɂMAX̓_
const int MAX_POINTS_OF_STROKE = IDAT_MAX_POINT;    // 1ɂMAX̓_
const int MAX_STROKES_OF_CHAR  = VALID_MAX_STROKE;  // 1ɂMAX̉搔

// M՗pϐ
int gPoint[MAX_POINTS_OF_CHAR * 2 * 4];
int gStroke[MAX_STROKES_OF_CHAR * 4];
// MՃf[^
u8 gLibDat[MAX_POINTS_OF_CHAR * 2];

// ݂̎
char gStrDic[64];

// ݂̃[h
char gStrMode[64];

void DrawDisplay0(CCtrlGraphics& graphic, int& modeCnt, int& dicCnt )
{
    graphic.SetDisplay(NN_GX_DISPLAY0);
    graphic.Clear(NN_GX_DISPLAY0);

    sprintf( gStrMode, "%s%s","[MODE] ",getModeName(modeCnt));
    sprintf( gStrDic , "%s%s","[DIC]  ",getDicName(dicCnt));
    graphic.DrawText(25,  2, " USEAGE:");
    graphic.DrawText(30, 12, " [A]       Hand Draw Start\n"       );
    graphic.DrawText(30, 22, " [LEFT]    Change Mode (RT_Mode)\n" );
    graphic.DrawText(30, 32, " [RIGHT]   Change Mode (RT_Mode)\n" );
    graphic.DrawText(30, 42, " [UP   ]   Change Dic\n"            );
    graphic.DrawText(30, 52, " [DOWN ]   Change Dic\n"            );

    graphic.DrawText(80, 102,  gStrMode );
    graphic.DrawText(80, 112,  gStrDic  );

    graphic.Swap( NN_GX_DISPLAY0 );
}


void DrawDisplay1( CCtrlGraphics& graphic )
{
    graphic.SetDisplay(NN_GX_DISPLAY1);
    graphic.Clear(NN_GX_DISPLAY1);    
    graphic.DrawText( 35, 120, "Press [A]:  Writing Start!\n" );
    graphic.Swap( NN_GX_DISPLAY1 );
}

void DrawUseage(CCtrlGraphics& graphic)
{
    graphic.SetDisplay(NN_GX_DISPLAY0);
    graphic.Clear(NN_GX_DISPLAY0);

    graphic.DrawText(25,  2, " USEAGE:");
    graphic.DrawText(30, 22, " [A]       Recoginition\n"          );
    graphic.DrawText(30, 32, " [B]       Clear data\n"            );
    graphic.DrawText(30, 42, " [Y]       Change Mode/Dic\n"       );
    graphic.DrawText(30, 52, " [LEFT]    Change Mode (RT_Mode)\n" );
    graphic.DrawText(30, 62, " [RIGHT]   Change Mode (RT_Mode)\n" );	
    graphic.DrawText(30, 72, " [START]   Application Exit\n"      );

    graphic.DrawText(80, 102,  gStrMode );
    graphic.DrawText(80, 112,  gStrDic  );

    graphic.Swap( NN_GX_DISPLAY0 );
}

void ClearCanvas(CCtrlGraphics& graphic)
{
    graphic.SetDisplay(NN_GX_DISPLAY1);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    InitDraw(NN_GX_DISPLAY1_WIDTH, NN_GX_DISPLAY1_HEIGHT);
    graphic.DrawInputBox();
    graphic.Swap( NN_GX_DISPLAY1 );
}

bool SelectHwrInfo( CCtrlGraphics& graphic, int& modeCnt, int& dicCnt )
{
    bool ret=false;
    short libRet;

    while (true)
    {
        // ʂ̕\
        DrawDisplay0(graphic,modeCnt,dicCnt);
        DrawDisplay1(graphic);
        graphic.WaitVsync(NN_GX_DISPLAY_BOTH);

        switch( GET_KEY_EVENT(D_USE_KEYEVENT) ){

        // [] [hؑ
        case D_BUTTON_RIGHT:
            if( modeCnt < MODE_NUM_MAX -1){
                modeCnt++;
            }else{
                modeCnt=0;
            }
            PRINT_OUT("[Set Mode=%s(0x%04x)]\n", getModeName(modeCnt), getModeType(modeCnt));

            libRet = hwr_mw_end();
            if( libRet != 0 ){
                PRINT_OUT("    [Error] hwr_mw_end()\n");
            }
            libRet = hwr_mw_init( dicCnt, modeCnt );
            if( libRet != 0 ){
                PRINT_OUT("    [Error] hwr_mw_init()\n");
                ret = false;
                goto EXIT;
            }
            break;

        // [] [hؑ
        case D_BUTTON_LEFT:
            if( modeCnt == 0 ){
                modeCnt = MODE_NUM_MAX -1;
            }else{
                modeCnt--;
            }        
            PRINT_OUT("[Set Mode=%s(0x%04x)]\n", getModeName(modeCnt), getModeType(modeCnt));

            libRet = hwr_mw_end();
            if( libRet != 0 ){
                PRINT_OUT("    [Error] hwr_mw_end()\n");
            }
            libRet = hwr_mw_init( dicCnt, modeCnt );
            if( libRet != 0 ){
                PRINT_OUT("    [Error] hwr_mw_init()\n");
                ret = false;
                goto EXIT;
            }
            break;

        // [] {^ ؑ
        case D_BUTTON_UP:
            if( dicCnt < DIC_NUM_MAX-1 ){
                dicCnt++;
            }else{
                dicCnt=0;
            }
            PRINT_OUT("[Set Dic=%s]\n", getDicName(dicCnt));

            // ؂ւ烂[hK؂Ȓlɂ
            modeCnt=0;

            libRet = hwr_mw_end();
            if( libRet != 0 ){
                PRINT_OUT("    [Error] hwr_mw_end()\n");
            }
            libRet = hwr_mw_init( dicCnt, modeCnt );
            if( libRet != 0 ){
                PRINT_OUT("    [Error] hwr_mw_init()\n");
                ret = false;
                goto EXIT;
            }            
            break;


        // [] {^ ؑ
        case D_BUTTON_DOWN:
            if( dicCnt == 0 ){
                dicCnt = DIC_NUM_MAX -1;
            }else{
                dicCnt--;
            }
            PRINT_OUT("[Set Dic=%s]\n", getDicName(dicCnt));

            // ؂ւ烂[hK؂Ȓlɂ
            modeCnt=0;

            libRet = hwr_mw_end();
            if( libRet != 0 ){
                PRINT_OUT("    [Error] hwr_mw_end()\n");
            }
            libRet = hwr_mw_init( dicCnt, modeCnt );
            if( libRet != 0 ){
                PRINT_OUT("    [Error] hwr_mw_init()\n");
                ret = false;
                goto EXIT;
            }            
            break;
        // [A] {^ FJn
        case D_BUTTON_A:
            ret = true;
            goto EXIT;
        // [START] {^ AvI
        case D_BUTTON_START:
            ret = false;
            goto EXIT;
        default:
            break;
        }
    }

EXIT:
    return ret;
}



bool DrawData(CCtrlGraphics& graphic,  int& modeCnt, int& dicCnt ,nn::font::RectDrawer& drawer, nn::font::DispStringBuffer *pDrawStringBuf, nn::font::ResFont& font)
{
    short libRet;
    bool endFlag = false;

    int num_point_to_char;
    int num_stroke_to_char;
    int num_point_to_stroke;
    bool touch_start = true;// ^b`JntO

    bool error_flag = false;
    char *errString=NULL;
    bool isDrawing = true;

    ResultInfo resultInfo[DLL_RECV_CANDI];
    CODE_SIZE  resCode[DLL_RECV_CANDI];

    nn::hid::PadReader pad_reader;
    nn::hid::PadStatus pad_status;

    // ^b`y̏
    nn::hid::TouchPanelReader tp_reader;
    nn::hid::TouchPanelStatus tp_status, old_tp_status;

    glClearColor(0.0f, 0.0f, 0.0f, 1.0f);

DISP_CLEAN:
    // ʕ\
    DrawUseage(graphic);

    // ʕ\F͘go(\p)
    ClearCanvas(graphic);

    graphic.WaitVsync(NN_GX_DISPLAY_BOTH);

    error_flag = false;
    errString = NULL;

    // ez[NA
    MEMSET( gPoint, 0, sizeof(gPoint) );
    MEMSET( gStroke, 0, sizeof(gStroke) );
    MEMSET( gLibDat, 0, sizeof(gLibDat) );

    // MՏNA
    num_point_to_char   = 0;
    num_stroke_to_char  = 0;
    num_point_to_stroke = 0;


REDRAW:
    touch_start = true;// ^b`JntO
    endFlag = false;

    ResetDraw();


    // writing roop
    while (true)
    {
        // foCX̍XV
        pad_reader.ReadLatest( &pad_status);
        tp_reader.ReadLatest( &tp_status);

        // [A]{^ Fs
        if (pad_status.trigger & nn::hid::CTR::BUTTON_A){
            isDrawing = false;
            PRINT_OUT("Exec() Dic=%s, Mode=%s(0x%04x)]\n", getDicName(dicCnt), getModeName(modeCnt), getModeType(modeCnt));
            break;
        // [B]{^  // ͘gNAi㏑j
        }else if (pad_status.trigger & nn::hid::CTR::BUTTON_B){

            // ^b`XV
            old_tp_status = tp_status;
            isDrawing = true;

            // MՏNA
            num_point_to_char = 0;
            num_point_to_stroke = 0;
            num_stroke_to_char = 0;

            // MՏNA
            MEMSET( gPoint, 0, sizeof(gPoint) );
            MEMSET( gStroke, 0, sizeof(gStroke) );
            MEMSET( gLibDat, 0, sizeof(gLibDat) );

            goto DISP_CLEAN;

        // [] {^ [hؑ
        }else if (pad_status.trigger & nn::hid::CTR::BUTTON_RIGHT){
            if( modeCnt < MODE_NUM_MAX -1){
                modeCnt++;
            }else{
                modeCnt=0;
            }
            PRINT_OUT("[Set Mode=%s(0x%04x)]\n", getModeName(modeCnt), getModeType(modeCnt));

            libRet = hwr_mw_mode(modeCnt);
            if( libRet != 0 ){
                PRINT_OUT("    [Error] hwr_mw_mode()\n");
            }
            break;

        // [] {^ [hؑ
        }else if (pad_status.trigger & nn::hid::CTR::BUTTON_LEFT){
            if( modeCnt == 0 ){
                modeCnt = MODE_NUM_MAX -1;
            }else{
                modeCnt--;
            }        
            PRINT_OUT("[Set Mode=%s(0x%04x)]\n", getModeName(modeCnt), getModeType(modeCnt));

            libRet = hwr_mw_mode(modeCnt);
            if( libRet != 0 ){
                PRINT_OUT("    [Error] hwr_mw_mode()\n");
            }
            break;

        // [Y]{^ ݒ؂ւ
        }else if (pad_status.trigger & nn::hid::CTR::BUTTON_Y){
            endFlag = false;
            goto FINISH;

        // [START]{^ I
        }else if (pad_status.trigger & nn::hid::CTR::BUTTON_START){
            endFlag = true;
            goto FINISH;
        }

        // ^b`ꂽmF
        if (tp_status.touch)
        {
            // ͘gɃ^b`ꂽmF
            if (graphic.CheckTouchedInputBox( tp_status.x, tp_status.y))
            {

                // gɃ^b`ꂽAFʂNA
                if( isDrawing == false ){
                    isDrawing = true;

                    // ʕ\
                    DrawUseage(graphic);

                    // ʕ\F͘go(\p)
                    ClearCanvas(graphic);

                    graphic.WaitVsync(NN_GX_DISPLAY_BOTH);

                    error_flag = false;
                    errString = NULL;

                    // ez[NA
                    MEMSET( gPoint, 0, sizeof(gPoint) );
                    MEMSET( gStroke, 0, sizeof(gStroke) );
                    MEMSET( gLibDat, 0, sizeof(gLibDat) );

                    // MՏNA
                    num_point_to_char   = 0;
                    num_stroke_to_char  = 0;
                    num_point_to_stroke = 0;
                }


                // ړĂȂꍇ͖iQhbg͎blj
                if ((tp_status.x - old_tp_status.x > 2) || (old_tp_status.x - tp_status.x > 2) || 
                    (tp_status.y - old_tp_status.y > 2) || (old_tp_status.y - tp_status.y > 2))
                {
                    // zĂȂ𔻒f
                    if (num_point_to_char < MAX_POINTS_OF_CHAR)
                    {
                        if (num_point_to_stroke < MAX_POINTS_OF_STROKE &&
                            num_stroke_to_char < MAX_STROKES_OF_CHAR)
                        {
                            // MՂm
                            gPoint[(num_point_to_char * 2)]     = tp_status.x - graphic.GetInputBoxRect()->x;
                            gPoint[(num_point_to_char * 2 + 1)] = tp_status.y - graphic.GetInputBoxRect()->y;

                            gLibDat[(num_point_to_char * 2)]    = (u8)((u8)(gPoint[(num_point_to_char * 2)]/2) | PEN_DOWN_FLG); // PEN DOWN
                            gLibDat[(num_point_to_char * 2+1)]  = (u8)(gPoint[(num_point_to_char * 2 + 1)]/2);

                            num_point_to_char++;
                            num_point_to_stroke++;


                            // MՂ`
                            graphic.DrawLine( NN_GX_DISPLAY1, old_tp_status.x, old_tp_status.y, tp_status.x, tp_status.y, touch_start);

                            old_tp_status = tp_status;
                            touch_start = false;
                        }
                        else
                        {
                            // 𒴂Ăꍇ͌x
                            NN_LOG("Over Limit: point to stroke\n");
                            errString = "Over Limit: point to stroke\n";
                            error_flag = true;
                            break;
                        }
                    }
                    else
                    {
                        // 𒴂Ăꍇ͌x
                        NN_LOG("Over Limit: point to char\n");
                        errString = "Over Limit: point to char\n";
                        error_flag = true;
                        break;
                    }
                }
            }
            else
            { // ͂ݏôŁA揑ɂ
                touch_start = true;

                // Cuɂ PEN UPW܂߂
                gLibDat[((num_point_to_char-1)* 2)] &= PEN_DOWN_MASK;
            }
            
        }
        // ^b`Ȃꍇ
        else if(!touch_start)
        {
            touch_start = true;

            // Cuɂ PEN UPW܂߂
            gLibDat[((num_point_to_char-1)* 2)] -= 0x80;
        }

        // ̕ςڏۑ
        if (num_point_to_stroke > 0)
        {
            if(touch_start)
            {
                if (num_stroke_to_char < MAX_STROKES_OF_CHAR)
                {
                    gStroke[ num_stroke_to_char] = num_point_to_char - 1;
                    num_stroke_to_char++;
                    num_point_to_stroke = 0;
                }
            }
        }

        // MՒ̏ꍇ͉ʍXV
        if( isDrawing ){
            graphic.Swap(NN_GX_DISPLAY1);
            graphic.WaitVsync(NN_GX_DISPLAY_BOTH);
        }

    }

    MEMSET( resultInfo, 0, sizeof(resultInfo));
    MEMSET( resCode, 0, sizeof(resCode));
    libRet = hwr_mw_exec( gLibDat, num_point_to_char);
    if( libRet < 0 ){
        PRINT_OUT("Recognition Failed.\n");
    }
    for( int cnt=0;cnt<libRet; cnt++ ){
        getScore( &resultInfo[cnt], cnt );
        PRINT_OUT("Result = 0x%04x (%d)\n", resultInfo[cnt].moji, resultInfo[cnt].deg );
        resCode[cnt] = (CODE_SIZE)resultInfo[cnt].moji;
    }


    //  ʕ\
    graphic.SetDisplay(NN_GX_DISPLAY0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    InitDraw(NN_GX_DISPLAY0_WIDTH, NN_GX_DISPLAY0_HEIGHT);

    // FJn܂łɁAG[oĂꍇ
    if( error_flag ){
        DrawTextWithFont(&drawer, pDrawStringBuf, &font, errString );
    }else{
        char strMode[64];
        char strDic[64];

        sprintf( strDic ,"Dic   :[%s]", getDicName(dicCnt));
        sprintf( strMode,"Mode:[%s]", getModeName(modeCnt));

        DrawText(&drawer,pDrawStringBuf, &font, strDic , 150,  80 );
        DrawText(&drawer,pDrawStringBuf, &font, strMode, 150, 120 );

        if( libRet > 0 ){
            DrawTextWithFontResult(&drawer, pDrawStringBuf, &font, resCode, libRet );
        }else if( libRet == 0 ){
            DrawTextWithFont(&drawer, pDrawStringBuf, &font, "None" );
        }else{
            char buf[64];
            sprintf( buf,"Error(%d)", libRet );
            DrawTextWithFont(&drawer, pDrawStringBuf, &font, buf );
        }
    }
    graphic.Swap( NN_GX_DISPLAY0 );
    graphic.WaitVsync(NN_GX_DISPLAY_BOTH);


goto REDRAW;
FINISH: 

    return endFlag;
}


//--------------------------------------------------------
// nnMain
//--------------------------------------------------------
void nnMain()
{
    s16      libRet;
    int      dicCnt=0;
    int      modeCnt=0;

    // 
    nn::fs::Initialize();

    OS_MEM_INIT();
    PRINT_OUT2("MEM_INIT OK\n");

    FILE_IO_INIT();
    PRINT_OUT("FIL_IO_INIT OK\n");

#ifdef ENABLE_TIMESCALE
    OS_TICK_INIT();
    PRINT_OUT("OS_TICK_INIT OK\n");
#endif /* #ifdef ENABLE_TIMESCALE */

    // z[j[sł悤 nn::applet::Enable() ̂݌Ă
    // z[j[Jڂd{^NbNAX[vɂ͔Ή
    nn::applet::Enable();

    // foCX
    nn::Result result = nn::hid::Initialize();
    NN_UTIL_PANIC_IF_FAILED( result);

    // hwȑ
    libRet = hwr_mw_init( dicCnt, modeCnt );
    if( libRet != 0 ){
        PRINT_OUT("    [Error] hwr_mw_init()\n");
    }

    // tHgp
    nn::font::ResFont font;
    nn::font::RectDrawer drawer;

    CCtrlGraphics graphic;
    graphic.InitializeGraphics();

    // `惊\[X̍\z
    void *const drawerBuf = InitShaders(&drawer);

    // `敶pobt@̊m
    nn::font::DispStringBuffer *const pDrawStringBuf = AllocDispStringBuffer(10240);

    // ----------------------------------------------------------------------
    // tHgݒ
    // ----------------------------------------------------------------------
    // tHg̍\z
    InitFont(&font); 

    PRINT_OUT("Demo Start\n");

    while(true){

        // [hAI
        if( !SelectHwrInfo( graphic, modeCnt, dicCnt )){
            break;
        }

        // MՎ擾FJnAMՃNA܂
        if( DrawData( graphic, modeCnt, dicCnt, drawer, pDrawStringBuf, font ) == true ){
            goto END;
        }
    }
END:


    drawer.Finalize();

    // `惊\[X̔j
    OS_FREE(drawerBuf);

    // tHg̔j
    CleanupFont(&font);

    // `敶pobt@̉
    OS_FREE(pDrawStringBuf);
  
    // OtBbNX֘ȀI
    graphic.FinalizeGraphics();

    // I
    hwr_mw_end();
    nn::hid::Finalize();
    FILE_IO_TERM();
    OS_MEM_TERM();

    PRINT_OUT2("*** End of test ***\n");
    PRINT_OUT2("Demo End\n");

}

/*---------------------------------------------------------------------------*
  End of file
 *---------------------------------------------------------------------------*/

