/*--------------------------------------------------------------------------*
  Project:    HWR_Demo
  File:       demo.cpp

  Copyright (C) 2011 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/
/******************************************************************
                        include t@C
*******************************************************************/
#include "hwr_sample.h"

/* TvMՃf[^iЂ炪ȁj */
static const unsigned char defdat_U3042_hira[] = {
/*    xW yW    */
    0x92, 0x17, /* 1  y_EJn */
    0x28, 0x11,
    0x9e, 0x0a, /* 2  y_EJn */
    0x1b, 0x38,
    0xa7, 0x1b, /* 3  y_EJn */
    0x92, 0x33,
    0x91, 0x28,
    0xa8, 0x24,
    0xad, 0x30,
    0x29, 0x36,
    0x00, 0x00
};

/* WJpobt@ */
unsigned char* gDicBuff=NULL; 

/* o^ppobt@ */
unsigned char* gRegDicMem=NULL;

/* o͊i[p\ */
RECOG_DATA gRecgData;

#define D_SAMPLE_DIC_NAME       TEST_DATA_ROOT"dic/all2_u.bin"
#define D_SAMPLE_RCG_INK_DATA   defdat_U3042_hira
#define D_SAMPLE_REG_INK_DATA   defdat_U3042_hira
#define D_SAMPLE_RECOG_CODE     (unsigned short)0x3042
#define D_SAMPLE_REGIST_CODE    (unsigned short)0xE001
#define D_SAMPLE_REGIST_NUM     10

#ifdef __cplusplus
extern "C"
#endif /* #ifdef __cplusplus */

void HWR_Main( void )
{
    short libRet;
    long dicDataSize;
    long readSize;
    long inkDataSize;
    int  cnt;

    /*---------------------------------
     * O[oϐ
     *---------------------------------*/
    gDicBuff = NULL;                                /* f[^WJobt@ */
    memset( &gRecgData, 0, sizeof(gRecgData) );    /* RT_Exec()ƂI/Ff[^   */


    /*---------------------------------
     * f[^WJ
     *---------------------------------*/

    /* t@CI[v */
    FILE* dicFp = FILE_OPEN( D_SAMPLE_DIC_NAME, "rb" );
    if( dicFp == NULL ){
        PRINT_OUT("    [Error] %s Open Error.\n", D_SAMPLE_DIC_NAME );
        goto ERROR_END;
    }
    
    /* t@CTCY擾 */
    dicDataSize = FILE_GETSIZE( dicFp );
    
    /* f[^WJpobt@̎擾 */
    gDicBuff = (unsigned char*)OS_MALLOC_EX( D_MATH_ROUNDUP(dicDataSize, D_FILE_IO_ALIGNMENT), D_FILE_IO_ALIGNMENT );
    if( gDicBuff == NULL ){
        PRINT_OUT("    [Error] %s dic buffer alloc Error\n", D_SAMPLE_DIC_NAME );
        goto ERROR_END;
    }
    
    /* f[^WJ */
    readSize = (long)FILE_READ( gDicBuff, 1, dicDataSize , dicFp );
    if( readSize != dicDataSize ){
        PRINT_OUT("    [Error] %s  Read Error.\n", D_SAMPLE_DIC_NAME );
        goto ERROR_END;
    }
    
    /* t@CN[Y */
    if( dicFp ){
        FILE_CLOSE( dicFp );
        dicFp = NULL;
    }

    /*---------------------------------
     * HWRCu
     *---------------------------------*/
    PRINT_OUT("\n    ### RT_Init ###\n");
    libRet = RECOG_INIT( HWR_WAKU_W, HWR_WAKU_H, gDicBuff );
    if( libRet != RT_OK ){
        PRINT_OUT("    [ERROR] RT_Init() = %d\n", libRet );
        goto ERROR_END;
    }
    
    /*---------------------------------
     * HWRCu o^@\
     *---------------------------------*/
    PRINT_OUT("\n    ### RT_Register_Init ###\n");
    {
        gRegDicMem = (unsigned char*)OS_MALLOC( sizeof(unsigned char)*D_SAMPLE_REGIST_NUM*REGISTER_BLKSIZE);
        if( gRegDicMem == NULL ){
            PRINT_OUT("    [Error] %s register buffer alloc Error\n" );
            goto ERROR_END;
        }
        memset( gRegDicMem, 0, sizeof(unsigned char)*D_SAMPLE_REGIST_NUM*REGISTER_BLKSIZE );

        libRet = REGISTER_INIT( D_SAMPLE_REGIST_NUM, gRegDicMem );
        if( libRet != RT_OK ){
            PRINT_OUT("    [ERROR] RT_Register_Init() = %d\n", libRet );
            goto ERROR_END;
        }
    }


    /*---------------------------------
     * HWRCu o^̓o^
     *---------------------------------*/
    PRINT_OUT("\n    ### RT_Register_Set(0x%04X) ###\n", D_SAMPLE_REGIST_CODE);
    {
        // MՃf[^
        unsigned char iDat[DLL_SEND_INKS*2];

        memset( iDat, 0 ,sizeof(iDat));

        //MՃf[^ݒ
        strcpy( (char *)iDat, (const char *)D_SAMPLE_REG_INK_DATA );
    
        /* MՂ̃f[^擾 */
        long dataSize = (long)strlen( (const char *)D_SAMPLE_REG_INK_DATA );
    
        /* I_f[^ݒ */
        iDat[dataSize + 0]=0xFF;
        iDat[dataSize + 1]=0xFF;

        libRet = REGISTER_SET( D_SAMPLE_REGIST_CODE, iDat );
        if( libRet < 0 ){
            PRINT_OUT("    [ERROR] RT_Register_Set() = %d\n", libRet );
            goto ERROR_END;
        }
    }


    /*---------------------------------
     * HWRCuF[hݒ
     *---------------------------------*/
    PRINT_OUT("\n    ### RT_Mode (0x%04X)###\n", RMODE_ALL);
    libRet = RECOG_MODE( (unsigned short)RMODE_ALL);
    if( libRet != RT_OK ){
        PRINT_OUT("    [ERROR] RT_Mode() = %d\n", libRet );
        goto ERROR_END;
    }

    
    /*---------------------------------
     * HWRCuF
     *---------------------------------*/
    //MՃf[^ݒ
    strcpy( (char *)gRecgData.idat, (const char *)D_SAMPLE_RCG_INK_DATA );
    
    /* MՂ̃f[^擾 */
    inkDataSize = (long)strlen( (const char *)D_SAMPLE_RCG_INK_DATA );
    
    /* I_f[^ݒ */
    gRecgData.idat[inkDataSize + 0]=0xFF;
    gRecgData.idat[inkDataSize + 1]=0xFF;
    
    PRINT_OUT("\n    ### RT_Exec( 0x%04X ) ###\n", D_SAMPLE_RECOG_CODE );
    libRet = RECOG_EXEC( &gRecgData );
    if( libRet == RT_NG ){
        PRINT_OUT("    [ERROR] RT_Exec() = %d\n", libRet );
        goto ERROR_END;
    } else if( libRet == 0 ){
        PRINT_OUT("    Result Unknown\n");
    } else {
        /* Fʏo */
        for( cnt = 0; cnt < libRet; cnt++ ) {
            PRINT_OUT( "        [%d] Unicode:0x%04X (%d)\n", cnt+1, gRecgData.moji[cnt], gRecgData.deg[cnt] );
        }
    }
    
    /*---------------------------------
     * HWRCu o^o
     *---------------------------------*/
    PRINT_OUT("\n    ### RT_Register_Result ###\n");
    {
        unsigned short candi[DLL_REGISTER_CNADI];
        unsigned short code[D_SAMPLE_REGIST_NUM];

        memset( candi,0,sizeof(candi));
        memset( code,0,sizeof(code));

        libRet = REGISTER_RESULT( code , candi );
        if( libRet == RT_NG ){
            PRINT_OUT("    [ERROR] RT_Register_Result() = %d\n", libRet );
            goto ERROR_END;
        } else {
            /* Fʏo */
            for( cnt = 0; cnt < libRet; cnt++ ) {
                PRINT_OUT( "        [%d] Unicode:0x%04X (%d)\n", cnt+1, code[cnt], candi[cnt] );
            }
        }
    }

ERROR_END:
    /*---------------------------------
     * HWRCu o^mF
     *---------------------------------*/
    PRINT_OUT("\n    ### RT_Register_Info(1) ###\n");
    {
        unsigned short code[D_SAMPLE_REGIST_NUM];
        memset( code, 0 ,sizeof(code) );

        libRet = REGISTER_INFO( code );
        if( libRet == RT_NG ){
            PRINT_OUT("    [ERROR] RT_Register_Info() = %d\n", libRet );

        } else if( libRet == 0 ){
                PRINT_OUT( "        No Regist\n");
        } else {
            /* Fʏo */
            for( cnt = 0; cnt < libRet; cnt++ ) {
                PRINT_OUT( "        [%d] Unicode:0x%04X\n", cnt+1, code[cnt] );
            }
        }
    }
    /*---------------------------------
     * HWRCu o^폜
     *---------------------------------*/
    PRINT_OUT("\n    ### RT_Register_Delete(0x%04X) ###\n", D_SAMPLE_REGIST_CODE);
    {
        libRet = REGISTER_DELETE(D_SAMPLE_REGIST_CODE);
        if( libRet != RT_OK ){
            PRINT_OUT("    [ERROR] RT_Register_Delete() = %d\n", libRet );
        }
    }

    /*---------------------------------
     * HWRCu o^mF
     *---------------------------------*/
    PRINT_OUT("\n    ### RT_Register_Info(2) ###\n");
    {
        unsigned short code[D_SAMPLE_REGIST_NUM];
        memset( code, 0 ,sizeof(code) );

        libRet = REGISTER_INFO( code );
        if( libRet == RT_NG ){
            PRINT_OUT("    [ERROR] RT_Register_Info() = %d\n", libRet );
        } else if( libRet == 0 ){
                PRINT_OUT( "        No Regist\n");
        } else {
            /* Fʏo */
            for( cnt = 0; cnt < libRet; cnt++ ) {
                PRINT_OUT( "        [%d] Unicode:0x%04X\n", cnt+1, code[cnt] );
            }
        }
    }

    /*---------------------------------
     * HWRCu o^@\I
     *---------------------------------*/
    PRINT_OUT("\n    ### RT_Register_Term ###\n");
    {
        libRet = REGISTER_TERM();
        if( libRet != RT_OK ){
            PRINT_OUT("    [ERROR] RT_Register_Term() = %d\n", libRet );
        }
    }

    /*---------------------------------
     * HWRCuI
     *---------------------------------*/
    PRINT_OUT("\n    ### RT_Term ###\n");
    libRet = RECOG_TERM();
    if( libRet != RT_OK ){
        PRINT_OUT("    [ERROR] RT_Term() = %d\n", libRet );
    }


    /*---------------------------------
     * eI
     *---------------------------------*/
    if( gRegDicMem ){
        OS_FREE( gRegDicMem );
        gRegDicMem = NULL;
    }

    if( gDicBuff ){
        OS_FREE( gDicBuff );
        gDicBuff = NULL;
    }

    return;


}
