/*-----------------------------------------------------------------------*
 Project: [Common]
 File: [CTR_Utility.cpp]

 Copyright (C) 2009 Nintendo Co., Ltd. All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law. They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
*-----------------------------------------------------------------------*/
/******************************************************************
                        include t@C
*******************************************************************/
#include "CTR_Define.h"
#include "CTR_Utility.h"
#include <nn/os.h>
using namespace nn::os;
using namespace nn::hid;

#ifdef __cplusplus
extern "C" {
#endif

static FILE* gFp = NULL;
static char* gText=NULL;
static int   cmdCnt = 0;


/*!--------------------------------------------------------*
 @brief  : GetKeyEvent()
 @param  : Ȃ
 @return : {^ID
 @summary: {^܂Ƃ
 @note   : O nn::hid::Initilizse()sĂ邱
*----------------------------------------------------------*/
static int GetKeyEvent( void ){
    
    int  ret=0;
    // pbh
    nn::hid::PadReader padReader;
    nn::hid::PadStatus padStatus;

    while( 1 ){

        padReader.ReadLatest(&padStatus);

        // [A] ꂽ
        if(padStatus.trigger & nn::hid::BUTTON_A) {
            ret = D_BUTTON_A;
            break;
        }

        // [B] ꂽ
        if(padStatus.trigger & nn::hid::BUTTON_B) {
            ret = D_BUTTON_B;
            break;
        }

        // [R] ꂽ
        if(padStatus.trigger & nn::hid::BUTTON_R) {
            ret = D_BUTTON_R;
            break;
        }

        // [L] ꂽ
        if(padStatus.trigger & nn::hid::BUTTON_L) {
            ret = D_BUTTON_L;
            break;
        }

        //  ꂽ
        if(padStatus.trigger & nn::hid::BUTTON_RIGHT) {
            ret = D_BUTTON_RIGHT;
            break;
        }

        //  ꂽ
        if(padStatus.trigger & nn::hid::BUTTON_LEFT) {
            ret = D_BUTTON_LEFT;
            break;
        }

        //  ꂽ
        if(padStatus.trigger & nn::hid::BUTTON_UP) {
            ret = D_BUTTON_UP;
            break;
        }

        //  ꂽ
         if(padStatus.trigger & nn::hid::BUTTON_DOWN) {
            ret = D_BUTTON_DOWN;
            break;
        }

        // [X] ꂽ
        if(padStatus.trigger & nn::hid::BUTTON_X) {
            ret = D_BUTTON_X;
            break;
        }

        // [Y] ꂽ
        if(padStatus.trigger & nn::hid::BUTTON_Y) {
            ret = D_BUTTON_Y;
            break;
        }

        // [START] ꂽ
        if(padStatus.trigger & nn::hid::BUTTON_START) {
            ret = D_BUTTON_START;
            break;
        }
    }

    return ret;
}
/*!--------------------------------------------------------*
 @brief  : SinarioRead()
 @param  : Ȃ
 @return : {^ID
 @summary: {^܂Ƃ
 @note   : 
*----------------------------------------------------------*/
static int SinarioRead( void ){

    int  ret=0;
    char *p=NULL;
    int len=0;
    char *stKey=NULL;

    ret = D_BUTTON_SINARIO_EOF;
    /* t@CViI̓ǂݏo */
    while( (FILE_FGETS(gText, D_READ_LINE_MAX, gFp)) != NULL ) {
        
        // sR[h폜NULLI[ɕϊ
        p = gText;
        while( (*p != '\n') && ((*p != '\r')) ) {
             p++ ;
        }
        *p = '\0';

        // R}hԍ̕\
        cmdCnt++;
        PRINT_OUT("[%d] %s\n ", cmdCnt, gText );

        /*ꕶڂ#̓RgAEg*/
        if ( gText[0] == '#' ) {
            continue;
        }

        /* 󔒍s͖ */
        len = (int)STRLEN( gText );
        if ( len == 0 ) {
            continue;
        }

        /* Keyԍǂݍ */
        stKey = STRTOK( gText, ":" );
        if ( stKey == NULL ) {
            PRINT_OUT( "    [ERROR] Failed sinario read\n" );
            return -1;
        }


        // [A] 
        if( STRCMP( stKey,"A")==0) {
            ret = D_BUTTON_A;
            break;
        }

        // [B] 
        if(STRCMP( stKey,"B")==0) {
            ret = D_BUTTON_B;
            break;
        }

        // [R] 
        if(STRCMP( stKey,"R")==0) {
            ret = D_BUTTON_R;
            break;
        }

        // [L] ꂽ
        if(STRCMP( stKey,"L")==0) {
            ret = D_BUTTON_L;
            break;
        }

        //  ꂽ
        if(STRCMP( stKey,"6")==0) {
            ret = D_BUTTON_RIGHT;
            break;
        }

        //  ꂽ
        if(STRCMP( stKey,"4")==0) {
            ret = D_BUTTON_LEFT;
            break;
        }

        //  ꂽ
        if(STRCMP( stKey,"8")==0) {
            ret = D_BUTTON_UP;
            break;
        }

        //  ꂽ
        if(STRCMP( stKey,"2")==0) {
            ret = D_BUTTON_DOWN;
            break;
        }

        // [X] ꂽ
        if(STRCMP( stKey,"X")==0) {
            ret = D_BUTTON_X;
            break;
        }

        // [Y] ꂽ
        if(STRCMP( stKey,"Y")==0) {
            ret = D_BUTTON_Y;
            break;
        }

        // [START] ꂽ
        if(STRCMP( stKey,"E")==0) {
            ret = D_BUTTON_START;
            break;
        }
        // [0] ꂽ
        if(STRCMP( stKey,"0")==0) {
            ret = D_BUTTON_SINARIO_EOF;
            break;
        }

        cmdCnt++;

    }

    return ret;
}
/******************************************************************
            OJ֐
*******************************************************************/
/*!--------------------------------------------------------*
 @brief  : CTR_UtilityInit()
 @param  : ViIt@Ct@C 
 @return : {^ID
 @summary: Utility֌W̏
 @note   : 
*----------------------------------------------------------*/
int CTR_UtilityInit( char* path )
{
    int ret;
    int fileSize;

    // R}hԍ̏
    cmdCnt=0;
    gFp = NULL;
    gText=NULL;

    if( path == NULL ){
        PRINT_OUT("    Sinario file None\n");
        return 0;
    
    }

    if( gFp ){
        FILE_CLOSE( gFp );
        gFp = NULL;
    }
    // ViIt@C̓ǂݍ
    gFp = FILE_OPEN( path, "r") ;
    if(gFp == NULL){
        PRINT_OUT("    [ERROR] %s Open Error.\n",path );
        ret = -1;
        goto END;
    }else{
        PRINT_OUT( "   [Read]=<%s>\n",path );
        ret = 0;
    }

    fileSize = FILE_GETSIZE(gFp);
	fileSize = D_MATH_ROUNDUP(fileSize, D_FILE_IO_ALIGNMENT);
    if( fileSize <= 0 ){
        PRINT_OUT("    [ERROR] %s File Size < 0.\n", fileSize );
        ret = -1;
        goto END;
    }

    // FileReaddefault 32byte ALIGNMENT
    gText = (char*)OS_MALLOC_EX( fileSize, D_FILE_IO_ALIGNMENT );
    if( gText == NULL ){
        PRINT_OUT("    [ERROR] %s Open Error.\n",path );
        ret = -1;
    }else{
        MEMSET(gText,0,sizeof(char)*fileSize);
    }

END:
    return ret;
}

/*!--------------------------------------------------------*
 @brief  : CTR_UtilityTrem()
 @param  : Ȃ
 @return : Ȃ
 @summary: Utility֌W̏I
 @note   : 
*----------------------------------------------------------*/
int CTR_UtilityTrem( void )
{
    if( gFp ){
        FILE_CLOSE( gFp );
        gFp = NULL;
    }

    if( gText ){
        OS_FREE( gText );
        gText = NULL;
    }

    return 0;
}
/*!--------------------------------------------------------*
 @brief  : CTR_GetKeyEvent()
 @param  : isSinario 
 @return : {^ID
 @summary: {^܂Ƃ
 @note   : 
*----------------------------------------------------------*/
int CTR_GetKeyEvent( int isSinario ){

    int  ret=0;

    if( isSinario == D_USE_SINARIO ){
        ret = SinarioRead();
    }else{
        ret = GetKeyEvent();
    }

    return ret;
}

#ifdef __cplusplus
}
#endif

